use super::{EntityDatum, EntityDatumList, EntityDatumVisitor};

impl EntityDatumList for () {
    fn accept(&self, _: &mut impl EntityDatumVisitor) {}
}

impl<T: EntityDatum> EntityDatumList for T {
    fn accept(&self, visitor: &mut impl EntityDatumVisitor) {
        visitor.visit(self);
    }
}

impl<T0: EntityDatum> EntityDatumList for (T0,) {
    fn accept(&self, visitor: &mut impl EntityDatumVisitor) {
        visitor.visit(&self.0);
    }
}

impl<T0: EntityDatum, T1: EntityDatum> EntityDatumList for (T0, T1) {
    fn accept(&self, visitor: &mut impl EntityDatumVisitor) {
        visitor.visit(&self.0);
        visitor.visit(&self.1);
    }
}

impl<T0: EntityDatum, T1: EntityDatum, T2: EntityDatum> EntityDatumList for (T0, T1, T2) {
    fn accept(&self, visitor: &mut impl EntityDatumVisitor) {
        visitor.visit(&self.0);
        visitor.visit(&self.1);
        visitor.visit(&self.2);
    }
}

impl<T0: EntityDatum, T1: EntityDatum, T2: EntityDatum, T3: EntityDatum> EntityDatumList
    for (T0, T1, T2, T3)
{
    fn accept(&self, visitor: &mut impl EntityDatumVisitor) {
        visitor.visit(&self.0);
        visitor.visit(&self.1);
        visitor.visit(&self.2);
        visitor.visit(&self.3);
    }
}

impl<T0: EntityDatum, T1: EntityDatum, T2: EntityDatum, T3: EntityDatum, T4: EntityDatum> EntityDatumList
    for (T0, T1, T2, T3, T4)
{
    fn accept(&self, visitor: &mut impl EntityDatumVisitor) {
        visitor.visit(&self.0);
        visitor.visit(&self.1);
        visitor.visit(&self.2);
        visitor.visit(&self.3);
        visitor.visit(&self.4);
    }
}

impl<T0: EntityDatum, T1: EntityDatum, T2: EntityDatum, T3: EntityDatum, T4: EntityDatum, T5: EntityDatum> EntityDatumList
    for (T0, T1, T2, T3, T4, T5)
{
    fn accept(&self, visitor: &mut impl EntityDatumVisitor) {
        visitor.visit(&self.0);
        visitor.visit(&self.1);
        visitor.visit(&self.2);
        visitor.visit(&self.3);
        visitor.visit(&self.4);
        visitor.visit(&self.5);
    }
}
